import { getEntry } from './read-model-reducer';
import { useSelector } from 'react-redux';

function useReduxReadModelSelector(query) {
  if (typeof query === 'string') {
    return useSelector(function (state) {
      return getEntry(state.readModels, query);
    });
  }

  return useSelector(function (state) {
    return getEntry(state.readModels, {
      query: query
    });
  });
}

export { useReduxReadModelSelector };
//# sourceMappingURL=use-redux-read-model-selector.js.map