"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _redux = require("redux");

var _uuid = require("uuid");

var _viewModelReducer = require("./view-model/view-model-reducer");

var _readModelReducer = require("./read-model/read-model-reducer");

var _createResolveMiddleware = _interopRequireDefault(require("./create-resolve-middleware"));

var _deserializeInitialState = _interopRequireDefault(require("./internal/deserialize-initial-state"));

var createStore = function createStore(_ref) {
  var _ref$redux = _ref.redux;
  _ref$redux = _ref$redux === void 0 ? {} : _ref$redux;
  var _ref$redux$reducers = _ref$redux.reducers,
      reducers = _ref$redux$reducers === void 0 ? {} : _ref$redux$reducers,
      _ref$redux$middleware = _ref$redux.middlewares,
      middlewares = _ref$redux$middleware === void 0 ? [] : _ref$redux$middleware,
      _ref$redux$enhancers = _ref$redux.enhancers,
      enhancers = _ref$redux$enhancers === void 0 ? [] : _ref$redux$enhancers,
      _ref$redux$sagas = _ref$redux.sagas,
      customSagas = _ref$redux$sagas === void 0 ? [] : _ref$redux$sagas,
      _ref$viewModels = _ref.viewModels,
      viewModels = _ref$viewModels === void 0 ? [] : _ref$viewModels,
      _ref$jwtProvider = _ref.jwtProvider,
      jwtProvider = _ref$jwtProvider === void 0 ? undefined : _ref$jwtProvider,
      origin = _ref.origin,
      rootPath = _ref.rootPath,
      staticPath = _ref.staticPath,
      _ref$initialState = _ref.initialState,
      initialState = _ref$initialState === void 0 ? undefined : _ref$initialState,
      serializedState = _ref.serializedState,
      isClient = _ref.isClient;
  // eslint-disable-next-line no-console
  console.warn('createStore function is deprecated and will be removed in future versions, migrate to createResolveStore');
  var sessionId = (0, _uuid.v4)();

  if (serializedState != null && initialState != null) {
    throw Error("ambiguous initial state: both initialState and serializedState set");
  }

  var actualInitialState;

  if (serializedState != null) {
    actualInitialState = (0, _deserializeInitialState["default"])(viewModels, serializedState);
  } else {
    actualInitialState = initialState;
  }

  var resolveMiddleware = (0, _createResolveMiddleware["default"])();
  var combinedReducers = (0, _redux.combineReducers)((0, _extends2["default"])({}, reducers, {
    viewModels: _viewModelReducer.reducer,
    readModels: _readModelReducer.reducer,
    jwt: function jwt(_jwt) {
      if (_jwt === void 0) {
        _jwt = {};
      }

      return _jwt;
    }
  }));

  var appliedMiddlewares = _redux.applyMiddleware.apply(void 0, [resolveMiddleware].concat(middlewares));

  var composedEnhancers = _redux.compose.apply(void 0, [appliedMiddlewares].concat(enhancers));

  var store = (0, _redux.createStore)(combinedReducers, actualInitialState, composedEnhancers);
  resolveMiddleware.run(isClient, {
    store: store,
    resolveContext: {
      viewModels: viewModels,
      rootPath: rootPath,
      staticPath: staticPath,
      origin: origin,
      jwtProvider: jwtProvider
    },
    customSagas: customSagas,
    sessionId: sessionId
  });
  return store;
};

var _default = createStore;
exports["default"] = _default;
//# sourceMappingURL=create-store.js.map