"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var deserializeInitialState = function deserializeInitialState(viewModels, serializedInitialState) {
  var initialState = (0, _extends2["default"])({}, serializedInitialState, {
    viewModels: (0, _extends2["default"])({}, serializedInitialState.viewModels)
  });

  for (var viewModelIndex = 0; viewModelIndex < viewModels.length; viewModelIndex++) {
    var _viewModels$viewModel = viewModels[viewModelIndex],
        viewModelName = _viewModels$viewModel.name,
        deserializeState = _viewModels$viewModel.deserializeState;
    var viewModelInitialState = initialState.viewModels[viewModelName];

    for (var aggregateId in viewModelInitialState) {
      if (viewModelInitialState.hasOwnProperty(aggregateId)) {
        viewModelInitialState[aggregateId] = deserializeState(viewModelInitialState[aggregateId]);
      }
    }
  }

  return initialState;
};

var _default = deserializeInitialState;
exports["default"] = _default;
//# sourceMappingURL=deserialize-initial-state.js.map