"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _effects = require("redux-saga/effects");

var _actions = require("./actions");

var _actionTypes = require("../internal/action-types");

var _eventListenerSaga = _interopRequireDefault(require("./event-listener-saga"));

var connectViewModelSaga = /*#__PURE__*/_regenerator["default"].mark(function connectViewModelSaga(sagaArgs, action) {
  var sagaManager, sagaKey, client, viewModels, query, viewModel, state, _yield$call, data, _yield$call$meta, url, cursor;

  return _regenerator["default"].wrap(function connectViewModelSaga$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          sagaManager = sagaArgs.sagaManager, sagaKey = sagaArgs.sagaKey, client = sagaArgs.client, viewModels = sagaArgs.viewModels;
          query = action.query;
          return _context.delegateYield(sagaManager.stop("" + _actionTypes.DISCONNECT_VIEWMODEL + sagaKey), "t0", 3);

        case 3:
          viewModel = viewModels.find(function (model) {
            return model.name === query.name;
          });
          state = typeof viewModel.projection.Init === 'function' ? viewModel.projection.Init : null;
          _context.next = 7;
          return (0, _effects.put)((0, _actions.viewModelStateUpdate)(query, state, true));

        case 7:
          _context.next = 9;
          return (0, _effects.call)([client, client.query], query);

        case 9:
          _yield$call = _context.sent;
          data = _yield$call.data;
          _yield$call$meta = _yield$call.meta;
          url = _yield$call$meta.url;
          cursor = _yield$call$meta.cursor;
          _context.next = 16;
          return (0, _effects.put)((0, _actions.viewModelStateUpdate)(query, data, false));

        case 16:
          state = data;
          return _context.delegateYield(sagaManager.start("" + _actionTypes.CONNECT_VIEWMODEL + sagaKey, _eventListenerSaga["default"], sagaArgs, {
            url: url,
            cursor: cursor,
            query: query,
            viewModel: viewModel,
            state: state
          }), "t1", 18);

        case 18:
        case "end":
          return _context.stop();
      }
    }
  }, connectViewModelSaga);
});

var _default = connectViewModelSaga;
exports["default"] = _default;
//# sourceMappingURL=connect-view-model-saga.js.map