"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.reducer = exports.getEntry = exports.getEntryPath = exports.builtInSelectors = exports.namedSelectors = void 0;

var _getHash = _interopRequireDefault(require("../internal/get-hash"));

var _lodash = _interopRequireDefault(require("lodash.set"));

var _lodash2 = _interopRequireDefault(require("lodash.unset"));

var _lodash3 = _interopRequireDefault(require("lodash.get"));

var _lodash4 = _interopRequireDefault(require("lodash.clonedeep"));

var _actionTypes = require("../internal/action-types");

var _types = require("../types");

var namedSelectors = 'namedSelectors';
exports.namedSelectors = namedSelectors;
var builtInSelectors = 'builtInSelectors';
exports.builtInSelectors = builtInSelectors;

var getSelector = function getSelector(action) {
  return action.selectorId || action;
};

var getEntryPath = function getEntryPath(selector) {
  if (typeof selector === 'string') {
    return namedSelectors + "." + (0, _getHash["default"])(selector);
  }

  var _selector$query = selector.query,
      name = _selector$query.name,
      aggregateIds = _selector$query.aggregateIds,
      args = _selector$query.args;
  return builtInSelectors + "." + (0, _getHash["default"])(name) + "." + (0, _getHash["default"])(aggregateIds) + "." + (0, _getHash["default"])(args, 'no-args');
};

exports.getEntryPath = getEntryPath;

var getEntry = function getEntry(state, selector, placeholder) {
  return (0, _lodash3["default"])(state, getEntryPath(selector), placeholder);
};

exports.getEntry = getEntry;
var initialState = {};

var reducer = function reducer(state, action) {
  if (state === void 0) {
    state = initialState;
  }

  switch (action.type) {
    case _actionTypes.VIEWMODEL_STATE_UPDATE:
      return (0, _lodash["default"])((0, _lodash4["default"])(state), getEntryPath(getSelector(action)), {
        status: action.initial ? _types.ResultStatus.Requested : _types.ResultStatus.Ready,
        data: action.state
      });

    case _actionTypes.DROP_VIEWMODEL_STATE:
      var newState = (0, _lodash4["default"])(state);
      (0, _lodash2["default"])(newState, getEntryPath(getSelector(action)));
      return newState;

    default:
      return state;
  }
};

exports.reducer = reducer;
//# sourceMappingURL=view-model-reducer.js.map