"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _effects = require("redux-saga/effects");

var _getHash = _interopRequireDefault(require("../internal/get-hash"));

var _createSagaManager = _interopRequireDefault(require("../internal/create-saga-manager"));

var _actionTypes = require("../internal/action-types");

var _connectViewModelSaga = _interopRequireDefault(require("./connect-view-model-saga"));

var _disconnectViewModelSaga = _interopRequireDefault(require("./disconnect-view-model-saga"));

var viewModelsSaga = /*#__PURE__*/_regenerator["default"].mark(function viewModelsSaga(sagaArgs) {
  var sagaManager, action, query, selectorId, sagaKey, _query, _selectorId, _sagaKey;

  return _regenerator["default"].wrap(function viewModelsSaga$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          sagaManager = (0, _createSagaManager["default"])();

        case 1:
          if (!true) {
            _context.next = 18;
            break;
          }

          _context.next = 4;
          return (0, _effects.take)([_actionTypes.CONNECT_VIEWMODEL, _actionTypes.DISCONNECT_VIEWMODEL]);

        case 4:
          action = _context.sent;
          _context.t0 = action.type;
          _context.next = _context.t0 === _actionTypes.CONNECT_VIEWMODEL ? 8 : _context.t0 === _actionTypes.DISCONNECT_VIEWMODEL ? 12 : 16;
          break;

        case 8:
          query = action.query, selectorId = action.selectorId;
          sagaKey = selectorId || (0, _getHash["default"])(query);
          return _context.delegateYield(sagaManager.start("" + _actionTypes.CONNECT_VIEWMODEL + sagaKey, _connectViewModelSaga["default"], (0, _extends2["default"])({}, sagaArgs, {
            sagaManager: sagaManager,
            sagaKey: sagaKey
          }), action), "t1", 11);

        case 11:
          return _context.abrupt("break", 16);

        case 12:
          _query = action.query, _selectorId = action.selectorId;
          _sagaKey = _selectorId || (0, _getHash["default"])(_query);
          return _context.delegateYield(sagaManager.start("" + _actionTypes.DISCONNECT_VIEWMODEL + _sagaKey, _disconnectViewModelSaga["default"], (0, _extends2["default"])({}, sagaArgs, {
            sagaManager: sagaManager,
            sagaKey: _sagaKey
          }), action), "t2", 15);

        case 15:
          return _context.abrupt("break", 16);

        case 16:
          _context.next = 1;
          break;

        case 18:
        case "end":
          return _context.stop();
      }
    }
  }, viewModelsSaga);
});

var _default = viewModelsSaga;
exports["default"] = _default;
//# sourceMappingURL=view-models-saga.js.map