import { Command } from '@resolve-js/client';
import { SEND_COMMAND_FAILURE, SEND_COMMAND_REQUEST, SEND_COMMAND_SUCCESS } from '../internal/action-types';
export declare type CommandAction = {
    type: string;
    command: Command;
};
export declare type SendCommandRequestAction = {
    type: typeof SEND_COMMAND_REQUEST;
    usedByHook: boolean;
} & CommandAction;
export declare const sendCommandRequest: (command: Command, usedByHook: boolean) => SendCommandRequestAction;
export declare type SendCommandSuccessAction = {
    type: typeof SEND_COMMAND_SUCCESS;
    result: any;
} & CommandAction;
export declare const sendCommandSuccess: (command: Command, result: any) => SendCommandSuccessAction;
export declare type SendCommandFailureAction = {
    type: typeof SEND_COMMAND_FAILURE;
    error: any;
} & CommandAction;
export declare const sendCommandFailure: (command: Command, error: Error) => SendCommandFailureAction;
