import { AnyAction } from 'redux';
import { Command, CommandResult, CommandOptions } from '@resolve-js/client';
import { CommandBuilder } from '@resolve-js/react-hooks';
import { SendCommandFailureAction, SendCommandRequestAction, SendCommandSuccessAction } from './actions';
declare type HookData<TArgs extends any[]> = {
    execute: (...args: TArgs) => void;
};
declare type CommandReduxActionsCreators<TCmd extends Command> = {
    request?: (command: TCmd) => SendCommandRequestAction | AnyAction;
    success?: (command: TCmd, result: CommandResult) => SendCommandSuccessAction | AnyAction;
    failure?: (command: TCmd, error: Error) => SendCommandFailureAction | AnyAction;
};
export declare type CommandReduxHookOptions<TCmd extends Command> = {
    actions?: CommandReduxActionsCreators<TCmd>;
    commandOptions?: CommandOptions;
};
declare function useReduxCommand<TCmd extends Command>(command: TCmd): HookData<void[]>;
declare function useReduxCommand<TCmd extends Command>(command: TCmd, options: CommandReduxHookOptions<TCmd>): HookData<void[]>;
declare function useReduxCommand<TCmd extends Command>(command: TCmd, dependencies: any[]): HookData<void[]>;
declare function useReduxCommand<TCmd extends Command>(command: TCmd, options: CommandReduxHookOptions<TCmd>, dependencies: any[]): HookData<void[]>;
declare function useReduxCommand<TArgs extends any[], TCmd extends Command>(builder: CommandBuilder<TArgs, TCmd>): HookData<TArgs>;
declare function useReduxCommand<TArgs extends any[], TCmd extends Command>(builder: CommandBuilder<TArgs, TCmd>, options: CommandReduxHookOptions<TCmd>): HookData<TArgs>;
declare function useReduxCommand<TArgs extends any[], TCmd extends Command>(builder: CommandBuilder<TArgs, TCmd>, dependencies: any[]): HookData<TArgs>;
declare function useReduxCommand<TArgs extends any[], TCmd extends Command>(builder: CommandBuilder<TArgs, TCmd>, options: CommandReduxHookOptions<TCmd>, dependencies: any[]): HookData<TArgs>;
export { useReduxCommand };
