import { Reducer, Middleware, StoreEnhancer, Store } from 'redux';
import { Saga } from 'redux-saga';
import { Context } from '@resolve-js/client';
declare type ResolveRedux = {
    reducers?: {
        [key: string]: Reducer;
    };
    middlewares?: Middleware[];
    enhancers?: StoreEnhancer<any, any>[];
    sagas?: Saga[];
};
declare type ResolveStoreParameters = {
    redux?: ResolveRedux;
    initialState?: any;
    serializedState?: string;
};
declare const createResolveStore: (resolveContext: Context, params?: ResolveStoreParameters, isClient?: boolean) => Store;
export { createResolveStore };
