import { Event } from '@resolve-js/core';
import { Client, Context } from '@resolve-js/client';
export declare enum ResultStatus {
    Initial = "initial",
    Requested = "requested",
    Ready = "ready",
    Failed = "failed"
}
declare type QueryResultEntry = {
    status: ResultStatus;
    data?: any;
    timestamp?: number;
    error?: Error;
};
export declare type ReadModelResultEntry = QueryResultEntry;
export declare type ViewModelResultEntry = QueryResultEntry;
declare type ReadModelResultMapByArgs = {
    [key: string]: ReadModelResultEntry;
};
declare type ReadModelResultMapByResolver = {
    [key: string]: ReadModelResultMapByArgs;
};
export declare type ReadModelResultMapByName = {
    [key: string]: ReadModelResultMapByResolver;
};
declare type ViewModelResultMapByAggregateArgs = {
    [key: string]: ViewModelResultEntry;
};
declare type ViewModelResultMapByAggregateIds = {
    [key: string]: ViewModelResultMapByAggregateArgs;
};
export declare type ViewModelResultMapByName = {
    [key: string]: ViewModelResultMapByAggregateIds;
};
export declare type ReduxState = {
    readModels?: ReadModelResultMapByName;
    viewModels?: ViewModelResultMapByName;
};
export declare type ReduxStoreContext = {
    redux: {
        reducers?: {
            [key: string]: string;
        };
        middlewares?: any[];
        enhancers?: any[];
        sagas?: any[];
    };
    initialState: any;
    serializedState?: string;
    isClient: boolean;
    queryMethod: string;
} & Context;
export declare type ChildSagaArgs = {
    store: any;
    sessionId: any;
    queryIdMap: Map<string, string>;
    client: Client;
} & ReduxStoreContext;
export declare type RootSagaArgs = {
    customSagas: any[];
} & ChildSagaArgs;
export declare type ViewModelReactiveEvent = Event;
export {};
