import { QUERY_VIEWMODEL_REQUEST, QUERY_VIEWMODEL_SUCCESS, QUERY_VIEWMODEL_FAILURE, DROP_VIEWMODEL_STATE, CONNECT_VIEWMODEL, DISCONNECT_VIEWMODEL, VIEWMODEL_STATE_UPDATE, VIEWMODEL_EVENT_RECEIVED } from '../internal/action-types';
import { ViewModelQuery } from '@resolve-js/client';
import { ViewModelReactiveEvent } from '../types';
export declare type ViewModelAction = {
    query: ViewModelQuery;
    selectorId?: string;
};
export declare type QueryViewModelRequestAction = {
    type: typeof QUERY_VIEWMODEL_REQUEST;
} & ViewModelAction;
export declare const queryViewModelRequest: (query: ViewModelQuery, selectorId?: string | undefined) => QueryViewModelRequestAction;
export declare type QueryViewModelSuccessAction = {
    type: typeof QUERY_VIEWMODEL_SUCCESS;
    result: any;
} & ViewModelAction;
export declare const queryViewModelSuccess: (query: ViewModelQuery, result: any, selectorId?: string | undefined) => QueryViewModelSuccessAction;
export declare type QueryViewModelFailureAction = {
    type: typeof QUERY_VIEWMODEL_FAILURE;
    error: Error;
} & ViewModelAction;
export declare const queryViewModelFailure: (query: ViewModelQuery, error: Error, selectorId?: string | undefined) => QueryViewModelFailureAction;
export declare type ViewModelStateUpdateAction = {
    type: typeof VIEWMODEL_STATE_UPDATE;
    state: any;
    initial: boolean;
} & ViewModelAction;
export declare const viewModelStateUpdate: (query: ViewModelQuery, state: any, initial: boolean, selectorId?: string | undefined) => ViewModelStateUpdateAction;
export declare type ViewModelEventReceivedAction = {
    type: typeof VIEWMODEL_EVENT_RECEIVED;
    event: ViewModelReactiveEvent;
} & ViewModelAction;
export declare const viewModelEventReceived: (query: ViewModelQuery, event: ViewModelReactiveEvent, selectorId?: string | undefined) => ViewModelEventReceivedAction;
export declare type DropViewModelStateAction = {
    type: typeof DROP_VIEWMODEL_STATE;
} & ViewModelAction;
export declare const dropViewModelState: (query: ViewModelQuery, selectorId?: string | undefined) => DropViewModelStateAction;
export declare type ConnectViewModelAction = {
    type: typeof CONNECT_VIEWMODEL;
} & ViewModelAction;
export declare const connectViewModel: (query: ViewModelQuery, selectorId?: string | undefined) => ConnectViewModelAction;
export declare type DisconnectViewModelAction = {
    type: typeof DISCONNECT_VIEWMODEL;
} & ViewModelAction;
export declare const disconnectViewModel: (query: ViewModelQuery, selectorId?: string | undefined) => DisconnectViewModelAction;
