import { AnyAction } from 'redux';
import { QueryOptions, ViewModelQuery } from '@resolve-js/client';
import { ViewModelEventReceivedAction, ViewModelStateUpdateAction } from './actions';
import { ReduxState, ViewModelReactiveEvent } from '../types';
declare type HookData = {
    connect: () => void;
    dispose: () => void;
    selector: (state: ReduxState) => any;
};
declare type ViewModelReduxActionsCreators = {
    stateUpdate?: (query: ViewModelQuery, state: any, initial: boolean, selectorId?: string) => ViewModelStateUpdateAction | AnyAction;
    eventReceived?: (query: ViewModelQuery, event: ViewModelReactiveEvent, selectorId?: string) => ViewModelEventReceivedAction | AnyAction;
};
export declare type ReduxViewModelHookOptions = {
    actions?: ViewModelReduxActionsCreators;
    queryOptions?: QueryOptions;
    selectorId?: string;
};
export declare function useReduxViewModel(query: ViewModelQuery): HookData;
export declare function useReduxViewModel(query: ViewModelQuery): HookData;
export declare function useReduxViewModel(query: ViewModelQuery, options: ReduxViewModelHookOptions): HookData;
export declare function useReduxViewModel(query: ViewModelQuery, options: ReduxViewModelHookOptions): HookData;
export {};
